%define ALD_Ver		2.0

#USE gcc-5.5.0

%define OrgName beecrypt
%define mC_Version 1.2.4s

Name:         mC-%{OrgName}
License:      GPL
Summary:      The uClibc beecrypt static libraries
Version:      4.2.1
Release:      %{mC_Version}.0

#Source: https://sourceforge.net/projects/beecrypt/files/beecrypt/

Source: %{OrgName}-%{version}.tar.xz
Patch0: %{OrgName}-%{version}.patch

%define DestDir		/Embedded/uC-%{version}

%define DestDir /Embedded/mC/%{mC_Version}
%define _prefix /usr/mC/%{mC_Version}
# -----------------------------------------------------
%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}/mC/%{mC_Version}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%endif

# -----------------------------------------------------

%if %{have_auto_local}
%define __os_install_post %{nil}
%else
%define MakeLocCross 0
%endif

%if %{_CROSS}
%define CrossPath /cross/%{_target_cpu}
%else
%define CrossPath %{nil}
%endif

#------------------ CROSS DIR --------------------

%define target %{_arch}-linux-musl
%define docdir %{_defaultdocdir}/%{OrgName}

# ------------------- description ------------------------------------
%description
This package contains the beecrypt library
#-------------------------------
%package      %{_target_cpu}
Summary:      %{name} Cross-%{_target_cpu} Libraries
Buildarch:    noarch
autoreqprov:  0
%description  %{_target_cpu}
%{name} Cross-%{_target_cpu} Libraries

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{OrgName}-%{version}
%patch0 -b .orig -p0

sed -i s:"cppglue.lo":: Makefile.in
sed -i s:"cppglue.cxx":: Makefile.in

# ------------------- Build ------------------------------------------
%Build
export PATH=$PATH:%{CrossPath}%{_prefix}/bin
export GCC_NoHostPath=d

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -Os -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables -ffunction-sections -fdata-sections"
export CFLAGS="$OPTFLAGS -std=gnu99"
export LDFLAGS="-Wl,--gc-sections"
export CC="%{target}-gcc"

./configure \
%if %{_CROSS}
	--build=%{_build} \
	--host=%{target} \
%endif
	--prefix=%{_prefix} \
	--exec-prefix=%{_exec_prefix} \
	--libdir=%{_libdir} \
	--includedir=%{_includedir} \
	--enable-expert-mode \
	--disable-shared \
	--enable-static \
	--with-python=no \
	--without-cplusplus \
	--without-java \
	&>FConfigure_log.txt

make &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
export PATH=$PATH:%{CrossPath}%{_prefix}/bin
export GCC_NoHostPath=d

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
rm $RPM_BUILD_ROOT%{_libdir}/*.la

cp AUTHORS CONTRIBUTORS README $RPM_BUILD_ROOT%{docdir}/
ln -s /usr/share/doc/gpl-2.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING
ln -s /usr/share/doc/lgpl-2.1.txt $RPM_BUILD_ROOT%{docdir}/COPYING.LIB

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -target_platform=%{target}-
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean
%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Cross Files ------------------------------------
%files
%{_prefix}

# ------------------- Cross Files ------------------------------------
%if %{MakeLocCross}

%files %{_target_cpu}
%{CrossPath}%{_prefix}

%endif # MakeLocCross
